/**
 *  @file attributestrings.C
 *
 *  @brief Attribute string implementation.  This file will be autogenerated in
 *      the future
 */

//******************************************************************************
// Includes
//******************************************************************************

// STD
#include <stdint.h>
#include <stdlib.h>

// This component
#include <targeting/attributes.H>
#include <targeting/attributetraits.H>
#include <targeting/attributestrings.H>

namespace TARGETING {

//******************************************************************************
// attrToString<ATTR_CLASS>
//******************************************************************************

template<>
const char* attrToString<ATTR_CLASS> (
    AttributeTraits<ATTR_CLASS>::Type const& i_attrValue)
{
    switch (i_attrValue)
    {
        case CLASS_CARD:
            return "Card";
        case CLASS_ENC:
            return "Enclosure";
        case CLASS_CHIP:
            return "Chip";
        case CLASS_UNIT:
            return "Unit";
        case CLASS_DEV:
            return "Device";
        default:
            return "Cannot decode class";
    }
}

//******************************************************************************
// attrToString<ATTR_TYPE>
//******************************************************************************

template<>
const char* attrToString<ATTR_TYPE> (
    AttributeTraits<ATTR_TYPE>::Type const& i_attrValue)
{
    switch (i_attrValue)
    {
        case TYPE_PROC:
            return "Processor";
        case TYPE_EX:
            return "EX chiplet";
        default:
            return "Cannot decode type";
    }
}

//******************************************************************************
// attrToString<ATTR_MODEL>
//******************************************************************************

template<>
const char* attrToString<ATTR_MODEL> (
    AttributeTraits<ATTR_MODEL>::Type const& i_attrValue)
{
    switch (i_attrValue)
    {
        case MODEL_SALERNO:
            return "Salerno";
        default:
            return "Cannot decode model";
    }
}

} // End namespace TARGETING
